<?php

namespace Teknisa\SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class FctExcluirParcelasFatura {
    
    const NOME = "FCT_EXCLUIR_PARCELAS_FATURA";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param integer $nrorg
     * @param integer $nrseq
     * 
     * @return string
     */
    public function executar($nrseqcontrato, $nrorg, $dtrecisao = null, $idtpexclusao = 1) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        $procedure->addParam(new Param("P_NRSEQCONTRATO",    Param::PARAM_INPUT,  $nrseqcontrato,    Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_NRORG",            Param::PARAM_INPUT,  $nrorg,            Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_DTRECISAOCONTR",   Param::PARAM_INPUT,  $dtrecisao,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_IDTPEXCLUSAOPARC", Param::PARAM_INPUT,  $idtpexclusao,     Param::PARAM_TYPE_INT));
        $procedure->execute();
    }
    
}

?>