DROP VIEW ETL_MANUTRECEBSISTEMALINHAPROD
/

CREATE VIEW ETL_MANUTRECEBSISTEMALINHAPROD AS 
SELECT NMFANTCLIE, -- DIMENSO 00301 CLIENTE (NOME FANTASIA)
       NMPARCNEGOCIO, -- DIMENSO 00286 PARCEIRO (CLI-FOR)
       NMRAZSOCCLIE, -- DIMENSO 00401 RAZO SOCIAL DO CLIENTE
       NMFANTREVENDA, -- DIMENSO 00454 REVENDA (NOME FANTASIA)
       NMRAZSOCREVENDA, -- DIMENSO 00455 REVENDA (RAZO SOCIAL)
       DSANOMESCADA, -- DIMENSO 00435 ACEITE - MS
       ANCADACLIE, -- DIMENSO 00434 ACEITE - ANO
       NMGRUPCLIE, -- DIMENSO 00437 GRUPO DE CLIENTE
       CDGERENTECOMERC, -- DIMENSO 00321 GERENTE COMERCIAL (OPERADOR)
       CDAGENTENEGOCIO, -- DIMENSO 00322 AGENTE DE NEGCIOS (OPERADOR)
       CDTPCTRECEB, -- DIMENSO 00271 TIPO DE CONTA RECEBIDA
       DSBIMESTRE, -- DIMENSO 00011 BIMESTRE
       DSTRIMESTRE, -- DIMENSO 00012 TRIMESTRE
       DSSEMESTRE, -- DIMENSO 00013 SEMESTRE
       DSANOMESREC, -- DIMENSO 00432 REC.(BAIXA) - MS
       ANBAIXAREC, -- DIMENSO 00431 REC.(BAIXA) - ANO
       DTMESBAIXAREC,
       CDEMPRESA, -- DIMENSO 00264 EMPRESA
       NMLINPCLIEAPUR, -- DIMENSAO 00439 LINHA DE PRODUTO (NOME)
       CDSISTEMA, -- DIMENSO 00438 SISTEMA (SIGLA)
       CDPROCOMERCI,  -- DIMENSO 00040 PRODUTO COMERCIAL
       VRRECEBIDO_SISTLINPCLIE
  FROM (SELECT -- ####################################
               -- HISTORICO DA APURAO DO FATURAMENTO
               -- ####################################
               REL.NRORG, 
               REL.CDCLIENTE,
               REL.CDLINPCLIE,
               REL.NMLINPCLIEAPUR, -- DIMENSAO 00439 LINHA DE PRODUTO (NOME)
               REL.DTMESAPURLINP,
               REL.NRORDEMLINPCLIE,
               REL.QTSISTEMAS,
               REL.VRFATURADO_LINPCLIE,
               REL.VRFATURADO_CLIENTE,
               SAP.CDSISTEMA || ' - ' || SIS.NMSISTEMA CDSISTEMA, -- DIMENSO 00438 SISTEMA (SIGLA)
               CASE WHEN SAP.CDSISTEMA = 'WEB_CMP' AND CLI.CDGRUPCLIE IN ('0000000001', /* -> AGENT2B */ 
                                                                          '0000000002', /* -> TECFOOD */ 
                                                                          '0000000007', /* -> INFLIGHTOR */ 
                                                                          '0000000008', /* -> TECDIET */ 
                                                                          '0000000012', /* -> FORSALE */ 
                                                                          '0000000019') /* -> -- BIGDINNER */  THEN CLI.CDGRUPCLIE
                    ELSE SIS.CDPROCOMERCI 
                     END AS CDPROCOMERCI, -- DIMENSO 00040 PRODUTO COMERCIAL
               -- ############
               -- RECEBIMENTOS
               -- ############
               (REL.VRFATURADO_LINPCLIE / REL.VRFATURADO_CLIENTE * REL.VRRECEBIDO_CLIENTE) / REL.QTSISTEMAS VRRECEBIDO_SISTLINPCLIE,
               REL.VRFATURADO_LINPCLIE / REL.VRFATURADO_CLIENTE * REL.VRRECEBIDO_CLIENTE VRRECEBIDO_LINPCLIE,
               REL.VRRECEBIDO_CLIENTE,
               REL.NMFANTCLIE, -- DIMENSO 00301 CLIENTE (NOME FANTASIA)
               REL.NMPARCNEGOCIO, -- DIMENSO 00286 PARCEIRO (CLI-FOR)
               REL.NMRAZSOCCLIE, -- DIMENSO 00401 RAZO SOCIAL DO CLIENTE
               REL.NMFANTREVENDA, -- DIMENSO 00454 REVENDA (NOME FANTASIA)
               REL.NMRAZSOCREVENDA, -- DIMENSO 00455 REVENDA (RAZO SOCIAL)
               REL.DSANOMESCADA, -- DIMENSO 00435 ACEITE - MS
               REL.ANCADACLIE, -- DIMENSO 00434 ACEITE - ANO
               REL.NMGRUPCLIE, -- DIMENSO 00437 GRUPO DE CLIENTE
               REL.CDGERENTECOMERC, -- DIMENSO 00321 GERENTE COMERCIAL (OPERADOR)
               REL.CDAGENTENEGOCIO, -- DIMENSO 00322 AGENTE DE NEGCIOS (OPERADOR)
               REL.CDTPCTRECEB, -- DIMENSO 00271 TIPO DE CONTA RECEBIDA
               REL.DSBIMESTRE, -- DIMENSO 00011 BIMESTRE
               REL.DSTRIMESTRE, -- DIMENSO 00012 TRIMESTRE
               REL.DSSEMESTRE, -- DIMENSO 00013 SEMESTRE
               REL.DSANOMESREC, -- DIMENSO 00432 REC.(BAIXA) - MS
               REL.ANBAIXAREC, -- DIMENSO 00431 REC.(BAIXA) - ANO
               REL.DTMESBAIXAREC,
               REL.CDEMPRESA -- DIMENSO 00264 EMPRESA
          FROM CLIENTE CLI, SISTEMA SIS, SISTCONTLINPAPU SAP,
               (SELECT -- ####################################
                       -- HISTORICO DA APURAO DO FATURAMENTO
                       -- ####################################
                       HIS.NRORG, 
                       HIS.CDCLIENTE,
                       HIS.CDLINPCLIE,
                       HIS.NMLINPCLIEAPUR, -- DIMENSAO 00439 LINHA DE PRODUTO (NOME)
                       HIS.DTMESAPURLINP,
                       HIS.NRORDEMLINPCLIE,
                       HIS.QTSISTEMAS,
                       HIS.VRFATURADO_LINPCLIE,
                       SUM(HIS.VRFATURADO_LINPCLIE) OVER (PARTITION BY HIS.CDCLIENTE, HIS.DTMESAPURLINP) VRFATURADO_CLIENTE,
                       -- ############
                       -- RECEBIMENTOS
                       -- ############
                       REC.CONTA_AJUSTADA_RECEBIDA VRRECEBIDO_CLIENTE,
                       REC.NMFANTCLIE, -- DIMENSO 00301 CLIENTE (NOME FANTASIA)
                       REC.NMPARCNEGOCIO, -- DIMENSO 00286 PARCEIRO (CLI-FOR)
                       REC.NMRAZSOCCLIE, -- DIMENSO 00401 RAZO SOCIAL DO CLIENTE
                       REC.NMFANTREVENDA, -- DIMENSO 00454 REVENDA (NOME FANTASIA)
                       REC.NMRAZSOCREVENDA, -- DIMENSO 00455 REVENDA (RAZO SOCIAL)
                       REC.DSANOMESCADA, -- DIMENSO 00435 ACEITE - MS
                       REC.ANCADACLIE, -- DIMENSO 00434 ACEITE - ANO
                       REC.NMGRUPCLIE, -- DIMENSO 00437 GRUPO DE CLIENTE
                       REC.CDGERENTECOMERC, -- DIMENSO 00321 GERENTE COMERCIAL (OPERADOR)
                       REC.CDAGENTENEGOCIO, -- DIMENSO 00322 AGENTE DE NEGCIOS (OPERADOR)
                       REC.CDTPCTRECEB, -- DIMENSO 00271 TIPO DE CONTA RECEBIDA
                       REC.DSBIMESTRE, -- DIMENSO 00011 BIMESTRE
                       REC.DSTRIMESTRE, -- DIMENSO 00012 TRIMESTRE
                       REC.DSSEMESTRE, -- DIMENSO 00013 SEMESTRE
                       REC.DSANOMESREC, -- DIMENSO 00432 REC.(BAIXA) - MS
                       REC.ANBAIXAREC, -- DIMENSO 00431 REC.(BAIXA) - ANO
                       REC.DTMESBAIXAREC,
                       REC.CDEMPRESA -- DIMENSO 00264 EMPRESA
                  FROM -- ########################################################################
                       -- ########################################################################
                       -- ########################################################################
                       -- HISTORICO DA APURAO DO FATURAMENTO POR CLIENTE, MS E LINHA DE PRODUTO          
                       -- ########################################################################
                       -- ########################################################################
                       -- ########################################################################
                       (SELECT CLA.NRORG, CLA.CDCLIENTE, CLA.CDLINPCLIE, CLA.NMLINPCLIEAPUR,
                               DECODE(CLA.IDTIPLINPCAPUR, 'M', 1, 'L', 1, 'P', 2, 'A', 2) NRORDEMLINPCLIE,
                               CLA.DTMESAPURLINP, ADD_MONTHS(CLA.DTMESAPURLINP, 1) DTMESPOSTERIORAPURLINP,
                               CLA.IDTIPLINPCAPUR, QTS.QTSISTEMAS, CLA.NRUSUALINPAPUR,
                               CLA.IDMPROCLINPAPUR, CLA.IDLPROCLINPAPUR, CLA.VRLICENCUSOAPUR,
                               NVL(QTA.QTATIVAS,0) QTATIVAS , NVL(QTV.QTVALIDAS,0) QTVALIDAS,
                               NVL(CLA.QTMINIMAFATAPUR, 0) QTMINIMAFATAPUR, CLA.VRMENSALIDAAPUR,
                               CASE WHEN NVL(CLA.QTMINIMAFATAPUR, 0) > NVL(QTV.QTVALIDAS, 0) THEN NVL(CLA.QTMINIMAFATAPUR, 0) * CLA.VRMENSALIDAAPUR
                                    ELSE NVL(QTV.QTVALIDAS, 0) * CLA.VRMENSALIDAAPUR
                                END AS VRFATURADO_LINPCLIE
                          FROM CONTRATOLINPAPU CLA,
                               (SELECT SI.NRORG, SI.CDCLIENTE, SI.CDLINPCLIE, SI.DTMESAPURLINP, COUNT(*) AS QTSISTEMAS
                                  FROM SISTCONTLINPAPU SI
                                 WHERE SI.CDSISTEMA NOT IN ('WEB_ADM', 'WEB_AEV') -- IGNORA ADMINISTRADOR E AGENDADOR DE EVENTOS
                                 GROUP BY SI.NRORG, SI.CDCLIENTE, SI.CDLINPCLIE, SI.DTMESAPURLINP) QTS,
                               (SELECT LL.NRORG, LL.CDCLIENTE, LL.CDLINPCLIE, LL.DTMESAPURLINP, COUNT(*) AS QTATIVAS
                                  FROM CONTRATOLINPAPU CL, LINPLUSOAPUR LL
                                 WHERE LL.IDLUSOATIVAPUR = 'S'
                                   AND CL.CDCLIENTE = LL.CDCLIENTE
                                   AND CL.CDLINPCLIE = LL.CDLINPCLIE
                                   AND CL.DTMESAPURLINP = LL.DTMESAPURLINP
                                   AND CL.NRORG = LL.NRORG
                                   AND CL.IDTIPLINPCAPUR IN ('M', 'L')
                                 GROUP BY LL.NRORG, LL.CDCLIENTE, LL.CDLINPCLIE, LL.DTMESAPURLINP
                                 UNION ALL
                                SELECT LL.NRORG, LL.CDCLIENTE, LL.CDLINPCLIE, LL.DTMESAPURLINP, COUNT(*) AS QTATIVAS
                                  FROM CONTRATOLINPAPU CL, CAIXALUSOAPUR CX, LINPLUSOAPUR LL
                                 WHERE LL.IDLUSOATIVAPUR = 'S'
                                   AND CL.CDCLIENTE = LL.CDCLIENTE
                                   AND CL.CDLINPCLIE = LL.CDLINPCLIE
                                   AND CL.DTMESAPURLINP = LL.DTMESAPURLINP
                                   AND CL.NRORG = LL.NRORG
                                   AND CL.IDTIPLINPCAPUR IN ('P', 'A')
                                   AND CX.CDCLIENTE = LL.CDCLIENTE
                                   AND CX.CDLINPCLIE = LL.CDLINPCLIE
                                   AND CX.DTMESAPURLINP = LL.DTMESAPURLINP
                                   AND CX.NRLICENCAUSO = LL.NRLICENCAUSO
                                   AND CX.NRORG = LL.NRORG
                                 GROUP BY LL.NRORG, LL.CDCLIENTE, LL.CDLINPCLIE, LL.DTMESAPURLINP) QTA,
                               (SELECT LL.NRORG, LL.CDCLIENTE, LL.CDLINPCLIE, LL.DTMESAPURLINP, COUNT(*) AS QTVALIDAS
                                  FROM CONTRATOLINPAPU CL, LINPLUSOAPUR LL
                                 WHERE (LL.IDLUSOATIVAPUR = 'S' OR LL.DTVALIPERSAPUR > ADD_MONTHS(LAST_DAY(TRUNC(LL.DTMESAPURLINP)), -1))
                                   AND CL.CDCLIENTE = LL.CDCLIENTE
                                   AND CL.CDLINPCLIE = LL.CDLINPCLIE
                                   AND CL.DTMESAPURLINP = LL.DTMESAPURLINP
                                   AND CL.NRORG = LL.NRORG
                                   AND CL.IDTIPLINPCAPUR IN ('M', 'L')
                                 GROUP BY LL.NRORG, LL.CDCLIENTE, LL.CDLINPCLIE, LL.DTMESAPURLINP
                                 UNION ALL
                                SELECT LL.NRORG, LL.CDCLIENTE, LL.CDLINPCLIE, LL.DTMESAPURLINP, COUNT(*) AS QTVALIDAS
                                  FROM CONTRATOLINPAPU CL, CAIXALUSOAPUR CX, LINPLUSOAPUR LL
                                 WHERE (LL.IDLUSOATIVAPUR = 'S' OR CX.DTVALIPERCXAPUR > ADD_MONTHS(LAST_DAY(TRUNC(CX.DTMESAPURLINP)), -1))
                                   AND CL.CDCLIENTE = LL.CDCLIENTE
                                   AND CL.CDLINPCLIE = LL.CDLINPCLIE
                                   AND CL.DTMESAPURLINP = LL.DTMESAPURLINP
                                   AND CL.NRORG = LL.NRORG
                                   AND CL.IDTIPLINPCAPUR IN ('P', 'A')
                                   AND CX.CDCLIENTE = LL.CDCLIENTE
                                   AND CX.CDLINPCLIE = LL.CDLINPCLIE
                                   AND CX.DTMESAPURLINP = LL.DTMESAPURLINP
                                   AND CX.NRLICENCAUSO = LL.NRLICENCAUSO
                                   AND CX.NRORG = LL.NRORG
                                 GROUP BY LL.NRORG, LL.CDCLIENTE, LL.CDLINPCLIE, LL.DTMESAPURLINP) QTV
                         WHERE QTS.CDCLIENTE (+) = CLA.CDCLIENTE
                           AND QTS.CDLINPCLIE (+) = CLA.CDLINPCLIE
                           AND QTS.DTMESAPURLINP (+) = CLA.DTMESAPURLINP
                           AND QTS.NRORG (+) = CLA.NRORG
                           AND QTA.CDCLIENTE (+) = CLA.CDCLIENTE
                           AND QTA.CDLINPCLIE (+) = CLA.CDLINPCLIE
                           AND QTA.DTMESAPURLINP (+) = CLA.DTMESAPURLINP
                           AND QTA.NRORG (+) = CLA.NRORG
                           AND QTV.CDCLIENTE (+) = CLA.CDCLIENTE
                           AND QTV.CDLINPCLIE (+) = CLA.CDLINPCLIE
                           AND QTV.DTMESAPURLINP (+) = CLA.DTMESAPURLINP
                           AND QTV.NRORG (+) = CLA.NRORG) HIS,
                       -- ##############################
                       -- ##############################
                       -- ##############################
                       -- RECEBIMENTOS POR CLIENTE E MS               
                       -- ##############################
                       -- ##############################
                       -- ##############################
                       (SELECT REC.NRORG,
                               REC.CDCLIENTE,
                               REC.NMFANTCLIE, -- DIMENSO 00301 CLIENTE (NOME FANTASIA)
                               REC.NMPARCNEGOCIO, -- DIMENSO 00286 PARCEIRO (CLI-FOR)
                               REC.NMRAZSOCCLIE, -- DIMENSO 00401 RAZO SOCIAL DO CLIENTE
                               REC.NMFANTREVENDA, -- DIMENSO 00454 REVENDA (NOME FANTASIA)
                               REC.NMRAZSOCREVENDA, -- DIMENSO 00455 REVENDA (RAZO SOCIAL)
                               REC.DSANOMESCADA, -- DIMENSO 00435 ACEITE - MS
                               REC.ANCADACLIE, -- DIMENSO 00434 ACEITE - ANO
                               REC.NMGRUPCLIE, -- DIMENSO 00437 GRUPO DE CLIENTE
                               REC.CDGERENTECOMERC, -- DIMENSO 00321 GERENTE COMERCIAL (OPERADOR)
                               REC.CDAGENTENEGOCIO, -- DIMENSO 00322 AGENTE DE NEGCIOS (OPERADOR)
                               REC.CDTPCTRECEB, -- DIMENSO 00271 TIPO DE CONTA RECEBIDA
                               REC.DSBIMESTRE, -- DIMENSO 00011 BIMESTRE
                               REC.DSTRIMESTRE, -- DIMENSO 00012 TRIMESTRE
                               REC.DSSEMESTRE, -- DIMENSO 00013 SEMESTRE
                               REC.DSANOMESREC, -- DIMENSO 00432 REC.(BAIXA) - MS
                               REC.ANBAIXAREC, -- DIMENSO 00431 REC.(BAIXA) - ANO
                               REC.DTMESBAIXAREC,
                               REC.CDEMPRESA, -- DIMENSO 00264 EMPRESA
                               SUM(REC.CONTA_AJUSTADA_RECEBIDA) CONTA_AJUSTADA_RECEBIDA
                          FROM ETL_CONTARECEBIDA REC
                         WHERE REC.CDTPCTRECEB IN ('012001', -- MANUTENCAO MENSAL DE PRODUTO
                                                   '012000', -- MANUTENO MENSAL - EXTERIOR
                                                   '020002') -- MANUTENCAO MENSAL - REVENDA
                         GROUP BY REC.NRORG,
                                  REC.CDCLIENTE,
                                  REC.NMFANTCLIE,
                                  REC.NMPARCNEGOCIO,
                                  REC.NMRAZSOCCLIE,
                                  REC.NMFANTREVENDA,
                                  REC.NMRAZSOCREVENDA,
                                  REC.DSANOMESCADA,
                                  REC.ANCADACLIE,
                                  REC.NMGRUPCLIE,
                                  REC.CDGERENTECOMERC,
                                  REC.CDAGENTENEGOCIO,
                                  REC.CDTPCTRECEB,
                                  REC.DSBIMESTRE,
                                  REC.DSTRIMESTRE,
                                  REC.DSSEMESTRE,
                                  REC.DSANOMESREC,
                                  REC.ANBAIXAREC,
                                  REC.DTMESBAIXAREC,
                                  REC.CDEMPRESA) REC
                  WHERE 
--                        REC.CDCLIENTE IN (:P_CDCLIENTE, :P_CDCLIENTE2)  J02905110000128  J67945071001967
--                    AND REC.DTMESBAIXAREC BETWEEN :P_DATA AND :P_DATA2  01/01/2013       01/02/2013
--                    AND 
                        HIS.CDCLIENTE = REC.CDCLIENTE
                    AND HIS.NRORG = REC.NRORG
                    -- PARA RATEAR O VALOR RECEBIDO NO MS POR LINHA DE PRODUTO, 
                    -- USA O VALOR DA LINHA DE PRODUTO DO HISTRICO DA APURAO 
                    -- DO FATURAMENTO DO MS ANTERIOR
                    AND HIS.DTMESPOSTERIORAPURLINP = REC.DTMESBAIXAREC) REL
          WHERE SAP.CDCLIENTE = REL.CDCLIENTE
            AND SAP.CDLINPCLIE = REL.CDLINPCLIE
            AND SAP.DTMESAPURLINP = REL.DTMESAPURLINP
            AND SAP.NRORG = REL.NRORG
            AND SAP.CDSISTEMA NOT IN ('WEB_ADM', 'WEB_AEV') -- IGNORA ADMINISTRADOR E AGENDADOR DE EVENTOS
            AND SIS.CDSISTEMA = SAP.CDSISTEMA
            AND SIS.NRORG = SAP.NRORG
            AND CLI.CDCLIENTE = REL.CDCLIENTE
            AND CLI.NRORG = REL.NRORG
          ORDER BY REL.CDCLIENTE,
                   REL.DTMESAPURLINP,
                   REL.NRORDEMLINPCLIE,
                   REL.NMLINPCLIEAPUR,
                   SAP.CDSISTEMA)
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_MANUTRECEBSISTEMALINHAPROD','0.00.000'); END;
/
